package cc.smtweb.system.bpm.web.engine.dynPage;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.common.SwEnum;
import cc.smtweb.framework.core.mvc.service.SwListData;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Akmm at 2022/4/21 17:53
 * 新增操作，初始化定义的数据集
 */
public class DynPageAddHandler extends AbstractDynPageHandler {

    public R add() {
        //返回的数据，以dataset.name为key，查出的结果（bean或list）为value
        Map<String, Object> mapRet = new HashMap<>();
        for (PageDataset dataSet : datasets.list) {
            if (!dataSet.canEdit) {
                continue;
            }
            if (SwEnum.DatasetType.FORM.value.equals(dataSet.type)) {//单表
                //懒加载，给个空对象
                if (dataSet.lazy) {
                    mapRet.put(dataSet.name, new SwMap());
                    continue;
                }
                mapRet.put(dataSet.name, DynPageHelper.createBean(dataSet));
            } else if (SwEnum.DatasetType.TREE.value.equals(dataSet.type)) {//树
                mapRet.put(dataSet.name, new SwMap());
            } else if (!SwEnum.DatasetType.ENUM.value.equals(dataSet.type)) {//非枚举
                mapRet.put(dataSet.name, SwListData.create(null, 0));
            }
        }
        return R.success(mapRet);
    }
}
